[libcamera-devel] [PATCH] utils: update-mojo.sh: Add script for updating mojo

Paul Elder paul.elder at ideasonboard.com
Wed May 19 07:25:10 CEST 2021


Add a script to ease updating mojo from a chromium source tree.

Signed-off-by: Paul Elder <paul.elder at ideasonboard.com>

---
Note that this script includes the little patch to template_expander.py
to enable it to work with jinja2 3.0.0 (it still works with jinja2
2.10.x).
---
 utils/update-mojo.sh | 68 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 68 insertions(+)
 create mode 100755 utils/update-mojo.sh

diff --git a/utils/update-mojo.sh b/utils/update-mojo.sh
new file mode 100755
index 00000000..a57ea968
--- /dev/null
+++ b/utils/update-mojo.sh
@@ -0,0 +1,68 @@
+#!/bin/sh
+
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Update mojo copy from a chromium source tree
+
+if [ $# != 1 ] ; then
+	echo "Usage: $0 <chromium dir>"
+	exit 1
+fi
+
+ipc_dir="$(dirname "$(realpath "$0")")/ipc"
+chromium_dir="$1"
+
+if [ ! -d "${chromium_dir}/mojo" ] ; then
+	echo "Directory ${chromium_dir} doesn't contain mojo"
+	exit 1
+fi
+
+if [ ! -d "${chromium_dir}/.git" ] ; then
+	echo "Directory ${chromium_dir} doesn't contain a git tree"
+	exit 1
+fi
+
+# Get the chromium commit id
+version=$(git -C "${chromium_dir}" rev-parse --short HEAD)
+
+# Reject dirty trees
+if ! test -z "$(git -C "${chromium_dir}" status --porcelain)" ; then
+	echo "Chromium tree in ${chromium_dir} is dirty"
+	exit 1
+fi
+
+# Copy the diagnosis file
+cp "${chromium_dir}/tools/diagnosis/crbug_1001171.py" "${ipc_dir}/tools/diagnosis"
+
+# Copy the rest of mojo
+cp "${chromium_dir}/mojo/public/LICENSE" "${ipc_dir}/mojo/public"
+
+last_dir="$(pwd)"
+cd "${chromium_dir}" || exit
+find "./mojo/public/tools" -type f \
+     -not -path "*/generators/*" \
+     -not -path "*/fuzzers/*" \
+     -exec cp --parents "{}" "${ipc_dir}" ";"
+cd "$last_dir" || exit
+
+# Update the README files
+readme=$(cat <<EOF
+# SPDX-License-Identifier: CC0-1.0
+
+Files in this directory are imported from ${version} of Chromium. Do not
+modify them manually.
+EOF
+)
+
+echo "$readme" > "${ipc_dir}/mojo/README"
+echo "$readme" > "${ipc_dir}/tools/README"
+
+# Fix mojo support for jinja2 3.0.0
+template_expander="${ipc_dir}/mojo/public/tools/mojom/mojom/generate/template_expander.py"
+sed -i "/py_compile=.*$/d" "${template_expander}"
+
+cat <<EOF
+------------------------------------------------------------
+mojo updated. Please review and up-port local changes before
+committing.
+------------------------------------------------------------
+EOF
-- 
2.27.0



More information about the libcamera-devel mailing list